"use strict";
// Copyright (c) Jeremy Tuloup.
// Distributed under the terms of the Modified BSD License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var base_1 = require("@jupyter-widgets/base");
var version_1 = require("./version");
var sketch_1 = require("./sketch");
var SketchModel = /** @class */ (function (_super) {
    __extends(SketchModel, _super);
    function SketchModel() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SketchModel.prototype.defaults = function () {
        return __assign({}, _super.prototype.defaults.call(this), { _model_name: SketchModel.model_name, _model_module: SketchModel.model_module, _model_module_version: SketchModel.model_module_version, _view_name: SketchModel.view_name, _view_module: SketchModel.view_module, _view_module_version: SketchModel.view_module_version, value: '' });
    };
    SketchModel.serializers = __assign({}, base_1.DOMWidgetModel.serializers);
    SketchModel.model_name = 'SketchModel';
    SketchModel.model_module = 'jupyter-p5';
    SketchModel.model_module_version = version_1.EXTENSION_SPEC_VERSION;
    SketchModel.view_name = 'SketchView';
    SketchModel.view_module = 'jupyter-p5';
    SketchModel.view_module_version = version_1.EXTENSION_SPEC_VERSION;
    return SketchModel;
}(base_1.DOMWidgetModel));
exports.SketchModel = SketchModel;
var SketchView = /** @class */ (function (_super) {
    __extends(SketchView, _super);
    function SketchView() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SketchView.prototype.render = function () {
        var _this = this;
        setTimeout(function () {
            var value = _this.model.get('value');
            _this.sketch = new sketch_1.Sketch(value, _this.el);
        }, 0);
    };
    SketchView.prototype.remove = function () {
        if (this.sketch) {
            this.sketch.remove();
        }
    };
    return SketchView;
}(base_1.DOMWidgetView));
exports.SketchView = SketchView;
//# sourceMappingURL=widget.js.map